;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; homing_bullet
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    print "INIT ",pc
					STZ $1528,x
                    RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    print "MAIN ",pc
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR CODE_START          ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED:
				db $10,$F0

FALL:
 				STZ $B6,x
RETURN:
              RTS                     ; return           
CODE_START:
          JSR SUB_GFX             ; graphics routine
                    LDA $14C8,x             ; \ 
                    CMP #$08                ;  | if status != 8, return
                    BNE FALL              ; /
                    LDA $9D                 ; \ if sprites locked, return
                    BNE RETURN              ; /
					%SubOffScreen() ;SUB_OFF_SCREEN_HB

                    JSL $01A7DC             ; check for mario/sprite contact
					LDA $AA,x
					JSL $01802A             ; update position based on speed values
					STA $AA,x
					LDA $1528,x
					BNE NOT_MODE0
					JSR MODE0
					RTS
NOT_MODE0:
		CMP #$01
					BNE NOT_MODE1
					JSR MODE1
					RTS
NOT_MODE1:
			JSR MODE2
					RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ETC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODE0:
				LDA $94
					STA $1570,x
					LDA $95
					STA $1504,x
					LDA $96
					CLC
					ADC #$10
					STA $1594,x
					LDA $97
					ADC #$00
					STA $1602,x
					LDA #$01
					STA $1528,x
					%SubHorzPos()
                    TYA
                    STA $157C,x
					RTS

MODE1:
				JSR SPEED_DEC
					LDA $157C,x
					BNE MODE1_2
					LDA #$30
					STA $B6,x
					BRA MODE1_3
MODE1_2:
				LDA #$D0
					STA $B6,x
MODE1_3:
				LDA $1570,x
					AND #$F0
					STA $0F
					LDA $E4,x
					AND #$F0
					CMP $0F
					BNE MODE1_E
					LDA #$02
					STA $1528,x
MODE1_E:
				RTS

MODE2:
				;LDA $13
					;AND #$01
					;BNE MODE2_E
					LDA $B6,x
					BEQ MODE2_2
					CMP #$80
					BCC MODE2_1_2
					INC A
					STA $B6,x
					BRA MODE2_2
MODE2_1_2:
			DEC A
					STA $B6,x
MODE2_2:
				LDA $AA,x
					BEQ MODE2_3
					CMP #$80
					BCC MODE2_2_2
					INC A
					STA $AA,x
					BRA MODE2_3
MODE2_2_2:
			DEC A
					STA $AA,x
MODE2_3:
				LDA $B6,x
					BNE MODE2_E
					LDA $AA,x
					BNE MODE2_E
					STZ $1528,x
MODE2_E:
				RTS





SPEED_DEC:
           LDA $E4,x
                    SEC
                    SBC $1570,x
                    STA $0F
                    BNE LBL11
                    LDA #$01
                    STA $0F
LBL11:
               LDA $14E0,x
                    SBC $1504,x
                    BPL FACE_LEFT
                    JSR RIGHT_SPEED
                    BRA VERC
FACE_LEFT:
           CMP #$01
                    BEQ LEFT2
                    JSR LEFT_SPEED1
                    BRA VERC
LEFT2:
               JSR LEFT_SPEED2
VERC:
                LDA $D8,x
                    SEC
                    SBC $1594,x
                    STA $0F
                    BNE LBL12
                    LDA #$01
                    STA $0F
LBL12:
               LDA $14D4,x
                    SBC $1602,x
                    BPL FACE_UP
                    JSR DOWN_SPEED
                    BRA VER_E
FACE_UP:
             JSR UP_SPEED
VER_E:
               RTS

UP_SPEED:
            LDA $0F38
                    CMP #$00
                    BNE UP3
                    LDA $0F
                    CMP #$80
                    BCC UP2
                    LDA #$7F
UP2:
                 STA $0F
                    BRA UP5
UP3:
                 CMP #$02
                    BNE UP4
                    JSR UP1_1
                    BRA UP5
UP4:
                 JSR UP1_2
UP5:
                 LDA #$00
                    SEC
                    SBC $0F
                    STA $AA,x
                    RTS

DOWN_SPEED:
          LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    LDA $0F38
                    CMP #$00
                    BNE DOWN3
                    LDA $0F
                    CMP #$80
                    BCC DOWN2
                    LDA #$7F
DOWN2:
               STA $AA,x
                    RTS
DOWN3:
               CMP #$02
                    BNE DOWN4
                    JSR UP1_1
                    BRA DOWN5
DOWN4:
               JSR UP1_2
DOWN5:
               LDA $0F
                    STA $AA,x
                    RTS






UP1_1:

LOOPUP1:
             LDA $03
                    BEQ LOOPUP1E
                    LDA $0F
                    LSR A
                    STA $0F
                    DEC $03
                    LDA $03
                    BNE LOOPUP1
LOOPUP1E:
            LDA $0F
                    CMP #$80
                    BCC LOOPUP1EE
                    LDA #$7F
                    STA $0F
LOOPUP1EE:
           RTS

UP1_2:
               LDA $0F
                    CMP #$80
                    BCC LOOPUP3
                    LDA #$7F
                    STA $0F
                    STZ $03
                    RTS
LOOPUP3:
             LDA $03
                    BEQ LOOPUP2E
                    LDA $0F
                    ASL A
                    STA $0F
                    DEC $03
                    LDA $03
                    BNE UP1_2
LOOPUP2E:
            LDA $0F
                    CMP #$80
                    BCC LOOPUP2EE
                    LDA #$7F
                    STA $0F
LOOPUP2EE:
           RTS







LEFT_SPEED1:
         STZ $02
                    LDA $0F
                    CMP #$40
                    BCC LEFT1_2
                    LDA #$02
                    STA $02
                    STZ $03
                    JSR LEFT1_40
                    BRA LEFT1_3
LEFT1_2:
             CMP #$20
                    BCS LEFT1_3
                    LDA #$01
                    STA $02
                    STZ $03
                    JSR LEFT1_20
                    BRA LEFT1_3
LEFT1_3:
             LDA #$00
                    SEC
                    SBC $0F
                    STA $B6,x
                    RTS

LEFT1_40:
            
LOOP140:
             LDA $0F
                    CMP #$40
                    BCC LOOP140E
                    LSR A
                    STA $0F
                    INC $03
                    BRA LOOP140
LOOP140E:
            RTS
LEFT1_20:           
LOOP120:
            LDA $0F
                    CMP #$20
                    BCS LOOP120E
                    ASL A
                    STA $0F
                    INC $03
                    BRA LOOP140
LOOP120E:
            RTS

LEFT_SPEED2:
         STZ $03
                    INC $03
                    LDA $0F
                    LSR A
                    CLC
                    ADC #$80
                    STA $0F
                    LDA #$02
                    STA $02
                    JSR LEFT1_40
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $B6,x
                    RTS

RIGHT_SPEED:
         STZ $02
                    LDA #$00
                    SEC
                    SBC $0F
                    STA $0F
                    CMP #$40
                    BCC RIGHT_2
                    LDA #$02
                    STA $02
                    STZ $03
                    JSR LEFT1_40
                    BRA RIGHT_3
RIGHT_2:
             CMP #$20
                    BCS RIGHT_3
                    LDA #$01
                    STA $02
                    STZ $03
                    JSR LEFT1_20
                    BRA RIGHT_3
RIGHT_3:
             LDA $0F
                    STA $B6,x
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PROPERTIES:
          db $40,$00,$C0,$80

SUB_GFX:
             %GetDrawInfo()       ; after: Y = index to sprite tile map ($300)
                                            ;      $00 = sprite x position relative to screen boarder 
                                            ;      $01 = sprite y position relative to screen boarder 
											
                    PHX                     ; push sprite index
					LDA $14C8,x
					STA $0F
					LDA $157C,x
					TAX
					LDA $0F
					CMP #$08
					BEQ GFX2
					TXA
					CLC
					ADC #$02
					TAX
GFX2:
				LDA PROPERTIES,x
					STA $0F

                    LDA $00                 ; \ tile x position = sprite x location ($00)
                    STA $0300,y             ; /                    
                                        
                    LDA $01                 ; \ tile y position = sprite y location ($01) + tile displacement
                    STA $0301,y             ; /
                                 
					LDA #$A6
                    STA $0302,y             ; / 

                    LDA $0F
                    LDX $15E9               ;  |
                    ORA $15F6,x             ;  | get palette info
                    ORA $64                 ;  | ?? what is in 64, level properties... disable layer priority??
                    STA $0303,y             ; / store tile properties

                    PLX                     ; pull, X = sprite index
                    
                    LDY #$02
                    LDA #$00                ;  | A = number of tiles drawn - 1
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return